// Random Sketch Generator
// Version 0.4 beta by Guillaume Cornu

#define SAVE_SCREEN

#include <nostub.h>
#include <graph.h>
#include <stdlib.h>
#include <kbd.h>

int _ti89;

void draw()								            // fonction de dessin 
{
	SCR_RECT clipzone = {{0,0,159,99}}; // la zone de clipping est l'cran
	int x0,y0,x1,y1,i,lines,tmp;
	
	for (i = 1; i <= 2; i++)            // rpte le processus 2 fois
	{
		randomize();
		x0 = random(159);
		y0 = random(99);
		x1 = random(159);
		y1 = random(99);
		if ( x0 >= x1 )
		{
			tmp = x0;
			x0 = x1;
			x1 = tmp;
		}
		if ( y0 >= y1 )
		{
			tmp = y0;
			y0 = y1;
			y1 = tmp;
		}
		// ici le programme dessine 4 lignes puis 1 rectangle et 1 llipse
	  for (lines = 1; lines <= 4; lines++)
	  	{
			DrawClipLine(MakeWinRect(x0,y0,x1,y1),&clipzone,A_XOR);
			randomize();
			x0 = random(159);
			y0 = random(99);
			x1 = random(159);
			y1 = random(99);
			}
			
		DrawClipRect(MakeWinRect(x0,y0,x1,y1),&clipzone,A_XOR);
		randomize();
		x0 = random(159);
		y0 = random(99);
		x1 = random(159);
		y1 = random(99);
		DrawClipEllipse(x0,y0,x1,y1,&clipzone,A_XOR);
	}
}

int _main()
{ 
  int key;
        
 	ClrScr();			      	     // prsentation au dmarrage
	FontSetSys(F_8x10);
	DrawStr(30,2,"Random Sketch",A_NORMAL);
	DrawStr(45,16,"Generator",A_NORMAL);
	DrawLine(0,30,160,30,A_NORMAL);
	FontSetSys(F_4x6);
	DrawStr(20,33,"Version 0.4 beta by Guillaume Cornu",A_NORMAL);
	DrawLine(0,40,160,40,A_NORMAL);
	FontSetSys(F_6x8);
	DrawStr(10,90,"ENTER : draw, ESC : quit",A_NORMAL);
	
	do
	{
		key = ngetchx();
		if (key==13)
		{
			ClrScr();
			draw();
		}
	}
	while (key!=264);
		
	return 0;
}
